/*
 *        HttxsfIMIF.c 1.5 91/09/01  
 * 
 * Derived from xsfIMIF.c		1.0 91/08/13 Fujitsu Limited */
/*
****************************************************************************

              Copyright 1991, by FUJITSU LIMITED
              Copyright 1991, by Sun Microsystems, Inc.	      

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of FUJITSU LIMITED and Sun
Microsystems, Inc. not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

FUJITSU LIMITED AND SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

Auther: Riki	Kawaguchi	FUJITSU LIMITED
	Tomoki	Kuriki		FUJITSU LIMITED
	Hideki  Hiura           (hhiura@Sun.COM) Sun Microsystems, Inc.

****************************************************************************
*/
#ifndef lint
#ident  "@(#)HttxsfIMIF.c	1.25    93/03/30 SMI"
#endif

#ifdef X_LOCALE
#include <X11/Xlocale.h>
#else
#include <locale.h>
#endif
#include <stdio.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xresource.h>

#include <X11/keysymdef.h>

#include "Htt.h"
extern	htt_t	*htt;
#include "XSunIMProt.h"
#include "XSunExt.h"

extern void	Ximp_Send_Keypress_Return();
extern char     *GetStringDefault();

int		putback_flag;

Bool
iml_open(ic)
    FXimp_Client   *ic;
{

    iml_inst       *rv = NULL;
    wchar_t         buff[512];
    void *          status;
    int             rstatus = NULL;
    char           *default_if ;
    im_t           *im = htt->im;

    default_if = GetStringDefault("if_name", "If_name", (char *)NULL);
    if(!default_if){
        if ((default_if = (char *)getenv("HTT_IF_NAME")) == NULL)
	    if(!strncmp(HTT_CORE(htt)->locale_name, "ja", 2))
		default_if = DefaultIF ;
	    else
		default_if = "cm" ;
    }

    if((ic->If = (iml_if_t *)if_OpenIF(default_if, HTT_CORE(htt)->locale_name, im)) == NULL){
	return False;
    }
    if((ic->s = (iml_session_t *)if_CreateSC(ic->If, ic, "0")) == NULL){
	return False;
    }
    if_GetSCValue(ic->s, SC_STATUS, &status) ;

    if ( ic->preedit_window ) {
	MapPreeditWindow() ;
	DisplayCursor(CURRENT_CLIENT(htt), False) ;
    }
    return True;
}

/* IMLogic Close */
void
xsfIMLclose(ic)
    FXimp_Client   *ic;
{

    iml_inst       *rv = NULL;

    if(ic->s){
	if_DestroySC(ic->s);
	/*
	 * Status message area Free
	 */
	if ( ic->status_message ) {
	    free( ic->status_message ) ;
	    ic->status_message = NULL ;
	}
	/*
	 * Preedit message area Free
	 */
	if ( ic->preedit_text.preedit_char ) {
	    free( ic->preedit_text.preedit_char ) ;
	    ic->preedit_text.preedit_char = 0 ;
	    ic->preedit_text.preedit_char_len = 0 ;
	}
	/*
	 * Preedit attrib area Free
	 */
	if ( ic->preedit_text.preedit_attr ) {
	    free( ic->preedit_text.preedit_attr ) ;
	    ic->preedit_text.preedit_attr = 0 ;
	}
	ic->s = NULL ;
    }    
    return;

}

/* IMLogic KeyPress */
void
xsfKeyPress(ic, event)
    FXimp_Client   *ic;
    XEvent         *event;
{
#ifdef	DEBUG
    (void) dbg_printf("xsfKeyPress() ic \n");
    _iml_xdmem(ic, sizeof(FXimp_Client));
    (void) dbg_printf("XEvent \n");
    _iml_xdmem(event, sizeof(XEvent));
#endif				

    if_SendEvent(ic->s, event) ;
    Ximp_Send_Keypress_Return( ic , event );

#ifdef	DEBUG
    (void) dbg_printf("xsfKeyPress() return \n");
#endif				

    return;
}

/* IMLogic SetFocus */
void
xsfIMLsetfocus(ic)
    FXimp_Client   *ic;
{
    Display     *display = GET_HTT_VALUE(htt, display);

    int             root_x, root_y, win_x, win_y;
    Window          root, child;
    unsigned int    modifier_mask ;

    (void) XQueryPointer(display, ic->focus_window, &root, &child,
			 &root_x, &root_y, &win_x, &win_y, &modifier_mask);
#ifdef notdef
    if (modifier_mask & Mod3Mask) {
	keystate = MODE_SWITCH_ON;
    } else {
	keystate = MODE_SWITCH_OFF;
    }
#endif
    if_SetSCFocus(ic->s);
    if_SetSCValue(ic->s, SC_MODIFIER_MASK, modifier_mask);
    return;
}

/* IMLogic UnSetFocus */
void
xsfIMLunsetfocus(ic)
    FXimp_Client   *ic;
{
    if_UnsetSCFocus(ic->s);
}

/* IMLogic reset */
void
xsfIMLreset(ic)
    FXimp_Client   *ic;
{
    if_ResetSC(ic->s);
}

/* IMLogic result */
#ifdef LOOKUPCALLBACK
/*
 * NO LONGER LOOKUP CHOICE CALLBACK IS SUPPORTED
 * THERE ARE NO GUARANTEE ON THIS CHUNK OF CODE TO WORK
 */
void
xsfIMLlookstart(ic, event, prop)
    FXimp_Client   *ic;
    XEvent         *event;
    int            *prop;
{

    XIMLookupStartCallbackStruct *lsc;
    iml_inst       *rv = NULL;

#ifdef	DEBUG
    (void) dbg_printf("Xsf-IMLookupStart Called\n");
#endif				/* DEBUG */

    if (!ic->cell_link)
	return;
    if (!ic->cell_link->called_rv)
	return;

    lsc = (XIMLookupStartCallbackStruct *)
	& ic->cell_link->called_rv->operand;
    lsc->WhoIsMaster = (WhoIsMaster)prop[0];
    /*
     * lsc->CBPreference = (LayoutInfo *)malloc( sizeof( LayoutInfo ) ) ;
     */
    lsc->CBPreference->choice_per_window = prop[1];
    lsc->CBPreference->nrows = prop[2];
    lsc->CBPreference->ncolumns = prop[3];
    lsc->CBPreference->DrawUpDirection = (DrawUpDirection)prop[4];
    lsc->CBPreference->WhoOwnsLabel = (WhoOwnsLabel)prop[5];

#ifdef	DEBUG
    dbg_printf("	cell Address  : %8.8x\n", ic->cell_link);
    dbg_printf("	rrv Address  : %8.8x\n", ic->cell_link->called_rv);
    dbg_printf("	Operand Address  : %8.8x\n", lsc);
    dbg_printf("	CBP/WhoIsMaster  : %d\n", prop[0]);
    dbg_printf("	Pre/ChoicePerWin : %8.8x\n",
	       lsc->XIMPreference->choice_per_window);
    dbg_printf("	Pre/nrows        : %d\n", lsc->XIMPreference->nrows);
    dbg_printf("	Pre/ncolumns     : %d\n", lsc->XIMPreference->ncolumns);
    dbg_printf("	Pre/DrawUpDirect : %d\n",
	       lsc->XIMPreference->DrawUpDirection);
    dbg_printf("	Pre/WhoOwnsLabel : %d\n", lsc->XIMPreference->WhoOwnsLabel);
    dbg_printf("	CBP/ChoicePerWin : %d\n", prop[1]);
    dbg_printf("	CBP/nrows        : %d\n", prop[2]);
    dbg_printf("	CBP/ncolumns     : %d\n", prop[3]);
    dbg_printf("	CBP/DrawUpDirect : %d\n", prop[4]);
    dbg_printf("	CBP/WhoOwnsLabel : %d\n", prop[5]);
#endif				/* DEBUG */

    (void) IMLogic(ic->id, &rv,
		   IML_SEND_RESULTS, ic->cell_link->called_rv, NULL);

    imliinterpret(ic, rv, NULL, NULL, event);

    return rv ;

}

/* IMLogic Result2 */
void
xsfIMLlookprocess(ic, event, data)
    FXimp_Client   *ic;
    XEvent         *event;
    int             data;
{

    XIMLookupProcessCallbackStruct *lpc;
    iml_inst       *rv = NULL;

#ifdef	DEBUG
    (void) dbg_printf("Xsf-IMLookupProcess Called\n");
#endif				/* DEBUG */

    if (!ic->cell_link)
	return;
    if (!ic->cell_link->called_rv)
	return;

    lpc = (XIMLookupProcessCallbackStruct *)
	& ic->cell_link->called_rv->operand;

    lpc->index_of_choice_selected = data;

    (void) IMLogic(ic->id, &rv,
		   IML_SEND_RESULTS, ic->cell_link->called_rv, NULL);

    imliinterpret(ic, rv, NULL, NULL, event);

#ifdef	DEBUG
    (void) dbg_printf("Xsf-IMLookupProcess Return\n");
#endif				/* DEBUG */
    return;

}
#endif LOOKUPCALLBACK

/* IMLogic Result3 */
void
xsfIMLpreeditstartret(ic, event, data)
    FXimp_Client   *ic;
    XEvent         *event;
    int             data;
{

    iml_inst       *rv = NULL;

#ifdef	XSF_PREEDIT_RETURN_USED
#ifdef	DEBUG
    (void) dbg_printf("Xsf-IMPreeditstart Called\n");
#endif				/* DEBUG */

    if (!ic->cell_link)
	return;
    if (!ic->cell_link->called_rv)
	return;

    ic->cell_link->called_rv->operand = (caddr_t) & data;

    (void) IMLogic(ic->id, &rv,
		   IML_SEND_RESULTS, ic->cell_link->called_rv, NULL);

    imliinterpret(ic, rv, NULL, NULL, event);

#ifdef	DEBUG
    (void) dbg_printf("Xsf-IMPreeditstart Return\n");
#endif				/* DEBUG */
#endif	/* XSF_PREEDIT_RETURN_USED */
    return;

}

/* IMLogic Result4 */
void
xsfIMLpreeditcaretret(ic, event, data)
    FXimp_Client   *ic;
    XEvent         *event;
    int             data;
{

    iml_inst       *rv = NULL;
    XIMPreeditCaretCallbackStruct *pcc;

    if (!ic->cell_link)
	return;
    if (!ic->cell_link->called_rv)
	return;

    pcc = (XIMPreeditCaretCallbackStruct *)&ic->cell_link->called_rv->operand ;
    pcc->position = data;

    /*
     * $@$I!<$;$3$s$J$b$s;H$o$J$$$G$7$g$&!#(J
     * $@EvLL!"(Jimplement $@$O!"(Jpending $@$@$J!#(J
     */
    return;
}

void
xsfIMLbegin(ic, event)
    FXimp_Client   *ic;
    XEvent         *event;
{
    if_SetSCValue(ic->s, SC_Henkan_Mode, True) ;
}
