#ifndef lint
#ifdef sccs
static char     sccsid[] = "@(#)XSunIMCanna.h	1.13 93/02/21 SMI";
#endif
#endif

/******************************************************************

              Copyright 1991,1992,1993 by Sun Microsystems, Inc.

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and
that both that copyright notice and this permission notice appear
in supporting documentation, and that the name of Sun Microsystems, Inc.
not be used in advertising or publicity pertaining to distribution
of the software without specific, written prior permission.
Sun Microsystems, Inc. makes no representations about the suitability of
this software for any purpose.  It is provided "as is" without
express or implied warranty.

Sun Microsystems Inc. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
IN NO EVENT SHALL Sun Microsystems, Inc. BE LIABLE FOR ANY SPECIAL, INDIRECT
OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
OR PERFORMANCE OF THIS SOFTWARE.

  Author: Hideki Hiura (hhiura@Sun.COM)
	  				     Sun Microsystems, Inc.
******************************************************************/

#ifndef xim_imlogic_jle103_DEFIND
#define xim_imlogic_jle103_DEFIND

typedef struct _iml_session {
/* ---- Inherit Base class [imlogic_session] ----- */

#define xim_iml_inheritance_DEFIND
#include "XSunIMCore.h"
#undef  xim_iml_inheritance_DEFIND

/* ----- Derived class [jle103_session] declaration ---- */

wchar_t conversion_on_key ;
unsigned int   cslen ;
unsigned char *csbuf ;
unsigned int   csbuflen ; 
jrKanjiStatus   ks ;
jrKanjiStatusWithValue ksv ;

} iml_session_t;

#define xim_imlogic_session_DEFIND

typedef struct _cannaif_spec_t {
} cannaif_spec_t ;

#define DEFAULTPreEditTextBufferSize 512
#define DEFAULTPreEditAttrBufferSize 512
#define DEFAULTCommitedStringBufferSize 512
#define DEFAULTStatusStringRemainBufferSize 512
/*
 * for the active_ regions
 */
#define PREEDIT_IS_ACTIVE	0x00000001
#define STATUS_IS_ACTIVE	0x00000002
#define LOOKUP_IS_ACTIVE	0x00000004
#define AUX_IS_ACTIVE		0x00000008

/*
 * for the remainder flag due to handle pseudo_packet in eval_it()
 */

#define PRE_EDIT_DONE_REQUIRED	0x00000001
#define STATUS_DONE_REQUIRED	0x00000002
#define STATUS_DRAW_REQUIRED	0x00000004
#define IMM_COMMIT_REQUIRED	0x00000008

#define DEFAULT_OPENWINHOME "/usr/openwin"
#define OW_LOCALE_PATH "lib/locale"
#define MODE_DAT_PATH "htt/mode.dat"
#define XXXCOMPAT_MODE_DAT_PATH "se/sunview/mode.dat"
#define DEFAULT_MLEPATH "/usr/lib/mle"

#define MAX_ENV_OPCODE 153

/*
 * canna interface module private member functions
 */

Private void canna_destruct_session();
Private void destruct_session();
Private void canna_reset();
Private void canna_get_key();
Private void canna_get_key_map();
Private void canna_set_key_map();
Private int  canna_send_event();
Private void canna_set_keyboard_state();
Private void canna_conversion_on();
Private void canna_send_results();
Private void canna_send_commit();
Private void canna_make_conversion_on();
Private void canna_make_conversion_off();
Private int canna_make_status_string();
Private void canna_set_choice();
Private void canna_attr2feedback();
Private int canna_create_session();
Private void canna_select_unknown_control();
Private void canna_opsw_init();
Private int construct_canna_initial_data();
Private iml_inst **eval_it();
Private void  init_status_string();

Private void eval_canna_to_env_packet();
Private void destruct_session();

Private struct canna_to_env *get_cte();
Private env_commit();
Private iml_inst *make_preedit_erase_inst();
Private iml_inst *make_preedit_done_inst();
Private void canna_eval_results();
Private Bool	ims_canna_negotiation_pool();

Private ReadOneLine();	/* Alternative function of fgets() */

extern struct canna_to_env *canna_put();

#endif  xim_imlogic_jle103_DEFINED
